
/************************************************************************/
/*                                                                      */
/*	File Mover - Does the grunt work for PLUG - FMOVER.C		*/
/*                                                                      */
/*	Version 1.0, July  1987 					*/
/*                                                                      */
/*	Compiled under Lattice C version 3.20	(Large model -mls)	*/
/*                                                                      */
/*	Author: Lawrence E. Himes					*/
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "dglobal.h"
#include "dir.h"

  extern struct dir **dpl;
  extern int	  totalde;
  char *clbuf;			/* Cluster buffer  */

/****************************************************************/
/*                                                              */
/*	fmover	 () - Scan FAT and move files to holes		*/
/*                                                              */
/****************************************************************/

fmover ()
{
  unsigned clu, tclu, maxclu, hole;
  int x, vfy, r;
  struct dir *de;

	clbuf = getmem (clsize);
	if (!clbuf) return Nomem;
	vfy = getvfy ();
	setvfy ();
     /* de = dpl [totalde-1];	*/
	de = dpl [0];
	maxclu = de->fcluster;
	r = 0;
	cprintf ("\n");
	for (clu = 2;	clu < maxclu  ;  clu++ )   {
		tclu = getfate (clu);
		if (tclu) continue;
		hole = 1;		/* Set init hole size */
		tclu = clu;
		for (  ; !(getfate (tclu+1)); tclu++, hole++ ) ;
		if (tclu >= maxclu) break;
		x = bestfit (hole, clu);
		de = ( x < 0) ? NULL : dpl [x];
		r = putinfo (hole, clu, de);
		if (r) break;
		if (!de) clu = tclu;
		else dpl [x] = NULL;
	}
	if (!r) dumpfat (1);
	if (!vfy) rstvfy ();
	return r;
}


/****************************************************************/
/*                                                              */
/*	putinfo  () - Move a file				*/
/*                                                              */
/****************************************************************/

putinfo (hole, clu, de)
  unsigned hole, clu;
  struct dir *de;
{
  static int   cl_moved = 0;
  static int   cl_m	= 0;
  char name [14];
  int r = 0;
  unsigned s, c, sclu;
  union {
	int words [2];
	struct dir *dpt;
	struct dir_ch *dch;
  } b ;

  /****************************************
	cprintf ("\nHole at cluster %u, Size = %u, ", clu, hole);
	if (!de) {
		cprintf ("No best fit");
		return 0;
	}
	gnde (de, name);
	cprintf ("%s fits, Size = %lu", name, de->fsize);
	cprintf (". Move it? ");
	s = toupper (getch());
	if (s != 'Y') return 0;
  ****************************************/

	if (!de) return 0;

   /*************************************

	CAUTION! CAUTION! CAUTION!

	THE FOLLOWING CODE RELIES ON THE FACT THAT THE DIR_CH
	STRUCTURES ARE ALLOCATED WITH THE LATTICE GETMEM() WHICH
	ALWAYS RETURNS A ZERO OFFSET IN THE LARGE MODEL. THIS
	CODE WILL CAUSE DISASTROUS PROBLEMS IF DIRECTLY PORTED TO
	OTHER MEMORY ALLOCATION SCHEMES WHICH DO NOT EXHIBIT THIS
	CHARACTERISTIC.

    *************************************/


	b.dpt = de;
	b.words [0] = 0;		/* get dir_ch address  */

   /*************************************/

	sclu = clu;			/* Save cluster */
	for (s = de->fcluster;	 ; clu++ )   {
		r = rdcluster (s, clbuf);
		if (!r) r = wtcluster (clu, clbuf);
		if (r) goto _end;
		cprintf ("\b\b\b\b\b%d", ++cl_moved);
		++cl_m;
		c = getfate (s);
		putfate ((c >= Cutoff ? c : clu+1), clu);
		putfate (0, s);
		if (c < Cutoff) s = c;
		else break;
	}
	de->fcluster = sclu;		/* Set new first cluster */
	r = absdio (1, drive, b.dch->dirent, b.dch->secno, 1);
	if ((!r) && (cl_m >  15)) { r = dumpfat (cl_m = 0); }
_end:	return r;
}

